#include "community.h"
#include <algorithm>
#include <iostream>

void Community::cambiarVectorXMap() {
	std::vector<Community*>::iterator it_nbcomm;
	std::vector<unsigned int>::iterator it2;
	for (it_nbcomm=community_cuts1.begin();it_nbcomm!=community_cuts1.end();it_nbcomm++) {
		int dist = it_nbcomm - community_cuts1.begin();
		it2 = community_cuts2.begin() + dist;
		bestNeighbour* bn = new bestNeighbour();
		bn->C1 = this;
		bn->C2 = *it_nbcomm;
		bn->num = *it2;
		bn->den = (float)this->tDegrees()*(*it_nbcomm)->tDegrees();
		community_cuts.insert(bn);
	}
	haveMap = true;
	community_cuts1.clear();
	community_cuts2.clear();
}

void Community::addCommunityCut(Community* c, unsigned int n) {
	std::vector<Community*>::iterator it;
	it = std::find(community_cuts1.begin(), community_cuts1.end(), c);
	if (it != community_cuts1.end())
		community_cuts2[it-community_cuts1.begin()] += n;
	else {
		community_cuts1.push_back(c);
		community_cuts2.push_back(n);
	}
}

void Community::removeCommunityCut(Community* c, unsigned int n) {
	std::vector<Community*>::iterator it;
	std::vector<unsigned int>::iterator it2;
	it = std::find(community_cuts1.begin(), community_cuts1.end(), c);

	if (it==community_cuts1.end())
		std::cout << "ERROR" << std::endl;

	int dist = it - community_cuts1.begin();
	it2 = community_cuts2.begin() + dist;

	if (*it2 > n)
		*it2 -= n;
	else {
		community_cuts2.erase(it2);
		community_cuts1.erase(it);
	}
}

void Community::setCommunityCutWithMap(Community* c, int n) {
	if (this==c)
		std::cout << "Corte con el mismo!" << std::endl;
	bestNeighbour* bn = new bestNeighbour();
	bn->C1 = this;
	bn->C2 = c;
	bn->num = n;
	bn->den = (float)this->tDegrees()*c->tDegrees();
	community_cuts.insert(bn);
//	std::cout << "El set tiene " << community_cuts.size() << std::endl;
}

void Community::removeCommunityCutWithMap(Community* c, int n) {
	std::set<bestNeighbour*, Compare>::iterator it;
	bestNeighbour* bn = new bestNeighbour();
	bn->C1 = this;
	bn->C2 = c;
	bn->num = n;
	bn->den = (float)this->tDegrees()*c->tDegrees();

	std::set<bestNeighbour*, Compare>::iterator it_nbcomm;

	it = community_cuts.find(bn);

	if (it==community_cuts.end()) {
		std::cout << "ERROR2" << std::endl;
		return;

	}
	bestNeighbour* bn2 = *it;
	community_cuts.erase(it);
	delete(bn2);
}


int Community::next_available_number = 1;

//PUBLIC

Community::Community() {
	sumDegrees = 0;
	sumEdges = 0;
	size = 1;
	removed = false;
	maxDegree = -1;

	haveMap = false; //Map instead of vector

	temp1 = 0;
	temp2 = 0;

	bn = NULL;

	//Setting this community's number
	number = next_available_number;
	next_available_number++;
}

Community::~Community() {

}

/*
void Community::recompute() {
	std::vector<Vertex*>::iterator it;
	sumDegrees = 0;
	for (it=vertices.begin();it!=vertices.end();it++) {
		sumDegrees += (*it)->getDegree();
	}	
}
*/

void Community::renew() {
	number = next_available_number;
	next_available_number++;
}

void Community::addNeighbour(Community* c) {
	community_cuts1.push_back(c);
	community_cuts2.push_back(1);
	
	if (c == this) {
		sumEdges += 1;
	}
	sumDegrees += 1;
}

bool Community::hasNeighbour(Community* c) {
	std::vector<Community*>::iterator nb_it;
	nb_it = std::find(community_cuts1.begin(), community_cuts1.end(), c);
	if (nb_it != community_cuts1.end())
		return true;
	return false;
}

void Community::addCommunity(Community* C, unsigned int prevcut, float t) { 
	sumDegrees += C->tDegrees();
	sumEdges += 2*prevcut + C->tEdges();
	size += C->getSize();
	if (C->getMaxDegree() > maxDegree)
		maxDegree = C->getMaxDegree();

	vertices.reserve(vertices.size() + C->vertices.size());
	vertices.insert(vertices.end(), C->vertices.begin(), C->vertices.end());
	//Neighbours and their communities get their map of community cuts updated
	std::vector<Community*>::iterator it_nbcomm;
	std::vector<unsigned int>::iterator it2;
	for (it_nbcomm=C->community_cuts1.begin();it_nbcomm!=C->community_cuts1.end();it_nbcomm++) {
		int dist = it_nbcomm - C->community_cuts1.begin();
		it2 = C->community_cuts2.begin() + dist;

		if (((*it_nbcomm)!=this)&&((*it_nbcomm)!=C)) {
			(*it_nbcomm)->addCommunityCut(this, (*it2));
			this->addCommunityCut((*it_nbcomm), (*it2));
		}
//		else
//			this->addCommunityCut(this, (*it2));
	}

//	if (t<8)
//		std::cout << "Size del vector de comunidades vecinas: " << community_cuts1.size() << ", " << community_cuts2.size() << std::endl;
/*	std::cout << "SOY" << std::endl;
	printCommunity();
	for (it_nbcomm=getCommunityCuts().begin();it_nbcomm!=getCommunityCuts().end();it_nbcomm++) {
		(*it_nbcomm).first->printCommunity();
		std::cout << (*it_nbcomm).second << std::endl;
	}
	std::cout << "*********************" << std::endl;
*/
}

void Community::addCommunityWithMap(Community* C, int intercut) { 
	std::set<bestNeighbour*, Compare>::iterator it_nbcomm;
	
	std::list<Community*> all_nb;

	for (it_nbcomm=C->getCommunityCuts().begin();it_nbcomm!=C->getCommunityCuts().end();it_nbcomm++) {
		all_nb.push_back((*it_nbcomm)->C2);

		(*it_nbcomm)->C2->temp1 = (*it_nbcomm)->num;
		(*it_nbcomm)->C2->removeCommunityCutWithMap(C, (*it_nbcomm)->num);
	}

	for (it_nbcomm=getCommunityCuts().begin();it_nbcomm!=getCommunityCuts().end();it_nbcomm++) {
		if ((*it_nbcomm)->C2->temp1==0)
			all_nb.push_back((*it_nbcomm)->C2);

		(*it_nbcomm)->C2->temp2 = (*it_nbcomm)->num;

		(*it_nbcomm)->C2->removeCommunityCutWithMap(this, (*it_nbcomm)->num);

		this->removeCommunityCutWithMap((*it_nbcomm)->C2, (*it_nbcomm)->num);
	}

	vertices.reserve(vertices.size() + C->vertices.size());
	vertices.insert(vertices.end(), C->vertices.begin(), C->vertices.end());
	sumDegrees += C->tDegrees();
	sumEdges += 2*intercut + C->tEdges();
	size += C->getSize();

	renew();

	std::list<Community*>::iterator all_nb_it;
	for (all_nb_it=all_nb.begin();all_nb_it!=all_nb.end();all_nb_it++) {
		if (((*all_nb_it)!=this)&&((*all_nb_it)!=C)) {		
			(*all_nb_it)->setCommunityCutWithMap(this, (*all_nb_it)->temp1+(*all_nb_it)->temp2);
			//if ((*all_nb_it)->temp1!=0)
				this->setCommunityCutWithMap((*all_nb_it), (*all_nb_it)->temp1+(*all_nb_it)->temp2);
		}	
		(*all_nb_it)->temp1 = 0;
		(*all_nb_it)->temp2 = 0;
	}

	C->sumDegrees = 0;
	C->sumEdges = 0;
	C->size = 0;
	C->vertices.clear();
	C->community_cuts.clear();
}

void Community::removeCommunity() { 
	sumDegrees = 0;
	sumEdges = 0;
	size = 0;
	maxDegree= -1;

	//Neighbours and their communities get their map of community cuts updated
	std::vector<Community*>::iterator it_nbcomm;
	std::vector<unsigned int>::iterator it2;
	for (it_nbcomm=community_cuts1.begin();it_nbcomm!=community_cuts1.end();it_nbcomm++) {
		if ((*it_nbcomm)!=this) {
			int dist = it_nbcomm - community_cuts1.begin();
			it2 = community_cuts2.begin() + dist;
			(*it_nbcomm)->removeCommunityCut(this, (*it2));
		}
//		if ((*it_nbcomm).first!=this)
//			removeCommunityCut((*it_nbcomm).first, (*it_nbcomm).second);
	}
	community_cuts1.clear();
	community_cuts2.clear();
	vertices.clear();
}

void Community::printCommunity() {
	std::vector<int>::iterator vertex_it;
	std::cout << "C: ";
	for (vertex_it=vertices.begin();vertex_it!=vertices.end();vertex_it++) {
		std::cout << (*vertex_it) << " ";
	}
	std::cout << std::endl;
}

void Community::computeBestNeighbour() {
	float tmax_num = 0;
	float tmax_den = 1;

	if (!haveMap) {
		Community* CNewBestNb;
		std::vector<Community*>::iterator comm_it2;
		std::vector<unsigned int>::iterator comm_it3;
		float t_num, t_den;

		comm_it2 = community_cuts1.begin();
		comm_it3 = community_cuts2.begin();
		float deg = (float)tDegrees();

		while (comm_it2!=community_cuts1.end()) {
			if ((*comm_it2)->getNumber() < getNumber()) {
				t_num = (float)(*comm_it3);
				t_den = deg * (float)(*comm_it2)->tDegrees();
				if ((t_num*tmax_den > t_den*tmax_num)) {
					tmax_num = t_num;
					tmax_den = t_den;
					CNewBestNb = *comm_it2;
				}
			}
			comm_it2++;
			comm_it3++;
		}
		if (tmax_num!=0) {
			if (bn==NULL) {
				bn = new bestNeighbour();
			}
			bn->C1 = this;
			bn->C2 = CNewBestNb;
			bn->num = tmax_num;
			bn->den = tmax_den;
			return;
		}
		if (bn!=NULL) {
			delete(bn);
			bn=NULL;
		}
	}
	else {
		std::set<bestNeighbour*, Compare>::iterator it = community_cuts.begin();
		if (bn==NULL) {
			bn = new bestNeighbour();
		}
		while (it!=community_cuts.end()) {
			if ((*it)->C1->getNumber()>(*it)->C2->getNumber()) {
				bn->C1 = (*it)->C1;
				bn->C2 = (*it)->C2;
				bn->num = (*it)->num;
				bn->den = (*it)->den;
				//tmax_num = (*it)->num;
				//tmax_den = (*it)->den;
				//return (*it)->C2;
				return;
			}
			it++;
		}
		if (bn!=NULL) {
			delete(bn);
			bn=NULL;
		}
	}

}

