#include "espiral.h"
#include "math.h"
#include <iostream>

float calcularRho(float K, float rho_i, float r_i, float r_j, float sep, float beta) {
	float K2 = pow(sep, 2) - pow(rho_i, 2);
//	float K2 = pow(r_i + 2 * r_j, 2);
	float K1 = -2 * rho_i;
	float alpha = rho_i;

//	std::cout << "K1: " << K1 << std::endl;
//	std::cout << "K2: " << K2 << std::endl;
	//Equation: x^2 + K1*x*cos(x-alpha) - K2 = 0
	//Derivative: 2*x + k1*cos(x-alpha) - K1*x*sin(x-alpha)
	float x_i;
//	float x_j = rho_i + sep/8;
//	float x_j = K * pow(pow(rho_i/K, 1/beta) + 2 * asin(sep/(2*rho_i)), beta);
	float x_j = K * pow(pow(rho_i/K, 1/beta) + sep/(2*rho_i), beta);
//std::cout << "rho_i: " << rho_i << std::endl;
	float f, f_der;
//	std::cout << "r_i: " << r_i <<std::endl;
//	std::cout << "r_j: " << r_j <<std::endl;
//	std::cout << "alpha: " << alpha <<std::endl;
//	std::cout << "rho_i: " << rho_i <<std::endl;
//	std::cout << "K: " << K <<std::endl;
//	std::cout << "x_j: " << x_j <<std::endl;
	int iter = 0;
	do {
		iter++;
		x_i = x_j;
		f = pow(x_i, 2) + K1 * x_i * cos(pow(x_i/K, 1/beta) - pow(alpha/K, 1/beta)) - K2;
		f_der = 2 * x_i + K1 * cos(pow(x_i/K, 1/beta) - pow(alpha/K, 1/beta)) - K1 * x_i * (1/beta) * (pow(x_i/K, 1/beta - 1)) * sin(pow(x_i/K, 1/beta) - pow(alpha/K, 1/beta));
//		std::cout << "f: " << f << std::endl;
//		std::cout << "f_der: " << f_der << std::endl;
		x_j = x_i - f / f_der;
//		std::cout << "x_i: " << x_i << std::endl;
//		std::cout << "x_j: " << x_j << std::endl;
	} while (((f > 0.1 * sep)||(f < -0.1 * sep)));
	return x_j;
}

