#ifndef _GRAPHICS_H_
#define _GRAPHICS_H_

#include "types.h"
#include <vector>
#include "network.h"
#include "community.h"
#include "engine.h"

class Graphics {

  private:
	std::vector<std::vector<int> > namesMesh;

	int xMeshSize;
	int yMeshSize;

	Engine* engine;

	tColor interpolate(tColor c1, float alfa1, tColor c2);
	float computeHostRatio(int maxDegree, float strength, int degree, bool weighted);
	tColor computeHostColor(int maxShellIndex, int shellIndex);
	
	void drawNode(Vertex* host, float u);
	void drawText(Vertex* host, float u, tColor textColor, float ppcV, float ppcH, float ratio, Network* n);
	void drawEdge(Vertex* host, float u, float ratio, Network* n, bool drawInternalCommunityEdges, bool drawExternalCommunityEdges);

	void compute_sizes_for_abstract_communities(std::list<Community*> lc, Network* n);
	void compute_sizes_for_real_communities(std::list<Community*> lc, Network* n);

  public:
	Graphics(Engine* engine);
	void generateNetworkFile(std::vector<Network*> nv);
	void generateNetworkFile(std::list<Community*> nv, Network* n, bool abstract);

};

#endif

