#include "pair_communities.h"
#include <iostream>

class ComparePairs {
  public:
	bool operator()(const int n1, const int n2) { return n2 < n1;};
};

void elegir(std::vector<Network*>& comm_graphs, Network* &elegida, int& mejor_puntaje, Network* it_comunidades1) {
	std::vector<Network*>::iterator it_comunidades2;
	std::map<int, Vertex*>::iterator it_vertices1, it_vertices2;

	for (it_comunidades2 = comm_graphs.begin(); it_comunidades2 != comm_graphs.end(); it_comunidades2++) {
//OK
		if ((*it_comunidades2)->aux == false) {
			it_vertices2 = (*it_comunidades2)->getMapIntVertices().begin();
			bool avanzar = true;
			int puntaje_comunidad2 = 0;
			for (it_vertices1 = it_comunidades1->getMapIntVertices().begin(); it_vertices1 != it_comunidades1->getMapIntVertices().end(); it_vertices1++) {
				//std::cout << "Tomo el vertice  " << *it_vertices1 << std::endl;
				avanzar = true;
				while (avanzar) {
					//std::cout << "Contra el vertice  " << *it_vertices2 << std::endl;
					if (it_vertices2 == (*it_comunidades2)->getMapIntVertices().end()) 
						avanzar = false;
					else {
						if (it_vertices2->first == it_vertices1->first) {
							puntaje_comunidad2++;
						}
						if (it_vertices2->first <= it_vertices1->first) {
							//std::cout << "Coinciden " << *it_vertices2 << " y " << *it_vertices1 << "\n";
							it_vertices2++;
							avanzar = true;
						}
						else
							avanzar = false;
					}
				}
			}
			if (puntaje_comunidad2 > mejor_puntaje) {
				mejor_puntaje = puntaje_comunidad2;
				elegida = *it_comunidades2;
			}
		}
	}
}


tParing pair_communities(std::vector<Network*> prev_comm_graphs, std::vector<Network*> comm_graphs, int snapshot_number) {

	tParing paring;
	std::vector<Network*>::iterator it_comunidades1, it_comunidades2;

	std::multimap<int, std::pair<Network*, Network*>, ComparePairs> mejores;
	std::list<std::pair<Network*, Network*> > final_pairs;

	int puntaje_total = 0;
	int iguales = 0;
	Network* mejor1, * mejor2;
	int cant_vertices = 0;
	int cant_vertices_now = 0;

	int necessary_adds = 0, necessary_remotions = 0;

//	std::cout << "Tam 1: " << prev_comm_graphs.size() << std::endl;
//	std::cout << "Tam 2: " << comm_graphs.size() << std::endl;

	for (it_comunidades1 = prev_comm_graphs.begin(); it_comunidades1 != prev_comm_graphs.end(); it_comunidades1++) {
		cant_vertices += (*it_comunidades1)->tVertices();

		int mejor_puntaje = -1;
		Network* elegida = NULL;
		elegir(comm_graphs, elegida, mejor_puntaje, *it_comunidades1);
		if (elegida != NULL) {
			std::pair<Network*, Network*> p;
			p.first = *it_comunidades1;
			(*it_comunidades1)->aux = false;
			elegida->aux = false;
			p.second = elegida;
			mejores.insert(std::pair<int, std::pair<Network*, Network*> >(mejor_puntaje, p));
		}
		else {
			std::cout << "ELEGIDA NULL" << std::endl;
		}
	}

	for (it_comunidades2 = comm_graphs.begin(); it_comunidades2 != comm_graphs.end(); it_comunidades2++) {
		cant_vertices_now += (*it_comunidades2)->tVertices();
	}

	std::multimap<int, std::pair<Network*, Network*>, ComparePairs>::iterator itt;
	itt = mejores.begin();
	int i = 0;
	for (itt=mejores.begin(); itt!=mejores.end(); ) {
		std::map<int, std::pair<Network*, Network*> >::iterator actual_pair = itt++;
		if ((actual_pair->second.first->aux == true)||(actual_pair->second.second->aux == true)) {
//			std::cout << "En i " << i << std::endl;
			int mejor_puntaje = -1;
			Network* elegida = NULL;
			elegir(comm_graphs, elegida, mejor_puntaje, actual_pair->second.first);
			if (elegida != NULL) {
				std::pair<Network*, Network*> p;
				p.first = actual_pair->second.first;
				actual_pair->second.first->aux = false;
				elegida->aux = false;
				p.second = elegida;
				mejores.insert(std::pair<int, std::pair<Network*, Network*> >(mejor_puntaje, p));
			//	std::cout << "Inserto con Puntaje " << mejor_puntaje << std::endl;
			}
			else {
//				std::cout << "ELEGIDA NULL" << std::endl;
			}
			mejores.erase(actual_pair);
			itt = mejores.begin();
			//std::cout << "Quedan " << mejores.size() << std::endl;
		}
		else {
			i++;
			mejores.erase(actual_pair);
			actual_pair->second.first->aux = true;
			actual_pair->second.second->aux = true;
			std::pair<Network*, Network*> p = actual_pair->second;
			final_pairs.push_back(p);
//			std::cout << i << " " << p.first->tVertices() - actual_pair->first << " " << actual_pair->first << " " << p.second->tVertices() - actual_pair->first << std::endl;
			necessary_adds += p.second->tVertices() - actual_pair->first;
			necessary_remotions += p.first->tVertices() - actual_pair->first;
			puntaje_total += actual_pair->first;
		}

	}

	std::cout << "Puntaje: " << puntaje_total*100/cant_vertices << "\% (i=" << i << ")" << " (" << puntaje_total << "/" << cant_vertices << ")" << std::endl;

	paring.final_pairs = final_pairs;
	paring.snapshot = snapshot_number;
	paring.vertices_now = cant_vertices_now;
	paring.necessary_adds = necessary_adds;
	paring.necessary_remotions = necessary_remotions;

	return paring;
}

