#ifndef _PARAMETERS_H_
#define _PARAMETERS_H_

#include <iostream>

class Parameters {
  private:
	std::string bckGnd;
	std::string color;
	float percentOfEdges;
	int minEdges;
	int widthResolution;
	int heightResolution;
	float fontZoom;
	float hstart;
	float hend;
	float vstart;
	float vend;
	float u;
	std::string format;
	//Options: "" or "java"
	std::string show;
	std::string outputType1File;
	std::string outputType2File;
	std::string outputRendType1File;
	std::string outputRendType2File;
	std::string outputPngType1File;
	std::string outputPngType2File;
	std::string inputFile;
	std::string inputNodeNamesFile;
	bool multigraph;
	bool weighted;
	int granularity;
	std::string renderer;
	std::string strengthsIntervals;
	bool noCliques;
	bool onlyGraphic;
	bool noGraphic;
	float opacity;
	bool isLogFile;
	int fromLayer;

  public:
	Parameters();
	std::string getBckGnd() { return bckGnd; }
	std::string getColor() { return color; }
	float getPercentOfEdges() { return percentOfEdges; }
	int getMinEdges() { return minEdges; }
	int getWidthResolution() { return widthResolution; }
	int getHeightResolution() { return heightResolution; }
	int getFontZoom() { return fontZoom; }
	float getHStart() { return hstart; }
	float getHEnd() { return hend; }
	float getVStart() { return vstart; }
	float getVEnd() { return vend; }
	float getU() { return u; }
	std::string getFormat() { return format; }
	std::string getShow() { return show; }
	std::string getOutputFile() { return outputRendType1File; }
	std::string getOutputType1File() { return outputRendType1File; }
	std::string getOutputType2File() { return outputRendType2File; }
	std::string getOutputRendType1File() { return outputRendType1File; }
	std::string getOutputRendType2File() { return outputRendType2File; }
	std::string getOutputPngType1File() { return outputPngType1File; }
	std::string getOutputPngType2File() { return outputPngType2File; }
	std::string getInputFile() { return inputFile; }
	std::string getInputNodeNamesFile() { return inputNodeNamesFile; }
	bool getMultigraph() { return multigraph; }
	bool getWeighted() { return weighted; }
	int getGranularity() { return granularity; }
	std::string getRenderer() { return renderer; }
	std::string getStrengthsIntervals() { return strengthsIntervals; }
	bool getNoCliques() { return noCliques; }
	bool getOnlyGraphic() { return onlyGraphic; }
	bool getNoGraphic() { return noGraphic; }
	float getOpacity() { return opacity; }
	bool getIsLogFile() { return isLogFile; }
	inline int getFromLayer() { return fromLayer; }

	void printHeader();
	void printHelp();
	void validateParameters(int argc, char* argv[]);

};

//The parameters object
extern Parameters parameters;

#endif

