#include "solution_submodular.h"
#include "stdlib.h"
#include "math.h"
#include <iostream>
#include <algorithm>

int step=0;
int tant;

std::list<Community*>::iterator join_it;
std::list<std::list<Community*> >::iterator list_it;
std::list<int>::iterator listc_it;
int cut;
std::list<Community*>::iterator comm_it;
std::vector<Community*>::iterator comm_it2;
std::vector<unsigned int>::iterator comm_it3;
std::vector<Community*>::iterator nb_it;
std::multiset<bestNeighbour*, Compare>::iterator it, it2;
bestNeighbour* bn;
float tmax_num;
float tmax_den;
Community* C1;
Community* CNewBestNb;
Community *c_new, *c_old;
std::multiset<bestNeighbour*, Compare>::iterator set_it, set_it2;
float deltaMNum;
float t_num, t_den;

bool t_inicial = false;
bool t_medio = false;		
bool t_final = false;

SolutionSubmodular::SolutionSubmodular(std::list<Community*>& m_listCommunities, Network* m_network) {
	kmax = -1;
	cambioHecho = false; //Cambio de vectores x mapas en las comunidades

	listCommunities = &m_listCommunities;
	network = m_network;
	//initial Q
	QNum = 0;
	QDen = 0;
	m2 = 0;

	std::list<Community*>::iterator comm_it;
	for (comm_it=listCommunities->begin();comm_it!=listCommunities->end();comm_it++) {
		QNum -= (float)(*comm_it)->tDegrees() * (*comm_it)->tDegrees();
		QDen += (*comm_it)->tDegrees();
		m2 += (*comm_it)->tDegrees();
	}
	QDen = QDen * QDen;
	Q = QNum / QDen;
	mNum = QNum;
	mDen = QDen;
	T = 1;
	deltaQJump = 0;
	//Initial ordering
	float t_num, t_den;
	int p=0;
	std::vector<Community*>::iterator comm_it2;
	std::vector<unsigned int>::iterator comm_it3;
	Community* C2;

	for (comm_it=listCommunities->begin();comm_it!=listCommunities->end();comm_it++) {
		Community* C1 = *comm_it;

		if (C1->tDegrees() > kmax)
			kmax = C1->tDegrees();

		C1->computeBestNeighbour();

		if (C1->bn!=NULL) {
			bestNeighbour* bn = new bestNeighbour();
			*bn = *(C1->bn);
			//C1->node = bestNeighbours.insert(bn);
			bestNeighbours.insert(bn);
		}

		C1->selected = 0;
	}

	tant = -1;

	//std::sort(bestNeighbours.begin(), bestNeighbours.end(), bestNeighbourOrder);
	//std::cout << "Q inicial: " << (float) QNum / QDen << std::endl;
}

bool SolutionSubmodular::proposeNeighbour() {
	//std::cout << "Tomando mejores t..." << std::endl;

	step++;
	tmax_num = 0;
	tmax_den = 1;
	listJoins.clear();
	listCuts.clear();

	//deltaQJump = 0.0; //In case of proyected Q

	int i=0;
	int p=0;

//	std::cout << "Best Neighbours.size() = " << bestNeighbours.size() << std::endl;
	it = bestNeighbours.begin();
	bn = *it;
	tmax_num = (float)bn->num;
	tmax_den = (float)bn->den;
	float prev = tmax_num/tmax_den;
	//std::cout << "tmax_num: " << tmax_num << std::endl;
	//std::cout << "tmax_den: " << tmax_den << std::endl;
	int j=0;
	do {
		j++;

		if ((bn->C1->selected!=step)&&(bn->C2->selected!=step)) {
			std::list<Community*> new_list;
			new_list.push_back(bn->C1);
			new_list.push_back(bn->C2);
			//bn->C1->printCommunity();
			//bn->C2->printCommunity();
			bn->C1->selected = step;
			bn->C2->selected = step;
			listJoins.push_back(new_list);
			listCuts.push_back(bn->num);
			bestNeighbours.erase(it);
			//printBN();
			//std::cout << "Hay un remove" << std::endl;

			//printBN();
			//it = bestNeighbours.begin();
		}
		it++;
		if (it != bestNeighbours.end()) {
			bn = *it;
			tmax_num = (float)bn->num;
			tmax_den = (float)bn->den;
			//std::cout << "tmax_num: " << tmax_num << std::endl;
			//std::cout << "tmax_den: " << tmax_den << std::endl;
		}
	} while ((tmax_num/tmax_den == prev)&&(it!=bestNeighbours.end()));
	//std::cout << "j: " << j << std::endl;
	if (listJoins.size()==0)
		return false;

	newT = (float) prev * m2;

	//if (step==1)
	//	std::cout << "t: " << newT << std::endl;

/*	if ((newT < tant/2)||(tant==-1)||(newT < 8)) {
		std::cout << "t: " << newT << ", Q: " << network->getQ() << std::endl;
		std::cout << "Comunidades: " << bestNeighbours.size() << std::endl;
		tant = newT;
	}
*/
	//if (fabs(newT-224.016) < 0.001)	{
	//if (abs(newT-86022) < 1) {
/*
	if (!t_inicial)	{
		t_inicial = true;
		it = bestNeighbours.begin();
		while (it!=bestNeighbours.end()) {
			logTInicial << (*it)->num/(*it)->den*m2 << "\n";
			it++;
		}

	}
	if ((newT<600000)&&(!t_medio)) {
		t_medio = true;
		it = bestNeighbours.begin();
		while (it!=bestNeighbours.end()) {
			logTMedio << (*it)->num/(*it)->den*m2 << "\n";
			it++;
		}

	}
	if ((newT<10)&&(!t_final)) {
		t_final = true;
		it = bestNeighbours.begin();
		while (it!=bestNeighbours.end()) {
			logTFinal << (*it)->num/(*it)->den*m2 << "\n";
			it++;
		}

	}
*/	
	deltaQComputed = false;
	return true;
}

void SolutionSubmodular::printBN() {
	std::multiset<bestNeighbour*, Compare>::iterator it;
	for (it=bestNeighbours.begin(); it!=bestNeighbours.end(); it++) {
		bestNeighbour* bnPtr = *it;
		std::cout << "(" << bnPtr->num/bnPtr->den << ") " << std::endl;
		bnPtr->C1->printCommunity();
		bnPtr->C2->printCommunity();
		std::cout << std::endl;
	}

}

void SolutionSubmodular::acceptNeighbour() {
	//std::cout << "Uniendo comunidades" << std::endl;
	Community* C2;

	//std::cout << "Lista: " << listJoins.size() << std::endl;
	listc_it = listCuts.begin();
	for (list_it=listJoins.begin();list_it!=listJoins.end();list_it++) {

		cut = *listc_it;
		listc_it++;
		join_it=(*list_it).begin();
		c_new = *join_it;
		join_it++;
		c_old = *join_it;

		c_old->removed = true;

		//c_new->printCommunity();
		//c_old->printCommunity();

		if (!cambioHecho)
			c_new->addCommunity(c_old, cut, newT);
		else	
			c_new->addCommunityWithMap(c_old, cut);
		c_new->renew();

		if (c_new->tDegrees() > kmax)
			kmax = c_new->tDegrees();

		if (!cambioHecho)
			c_old->removeCommunity();
		//c_new->printCommunity();
	}

	//std::cout << "T: de " << T << " a " << newT << std::endl;
	//std::cout << "m: de " << (float)oldMNum/mDen << " a " << (float)mNum/mDen << std::endl;
	//std::cout << newT << " " << Q << std::endl;
	//std::cout << "Q proyectado: de " << Q + ((float)mNum/mDen) * (1 - newT) << std::endl;
	for (list_it=listJoins.begin();list_it!=listJoins.end();list_it++) {

		join_it=(*list_it).begin();
		C1 = *join_it;
		join_it++;
		C2 = *join_it;

		if (C2->bn!=NULL) {
			bestNeighbours.erase(C2->bn);
		}

		//Recompute
		C1->computeBestNeighbour();
		if (C1->bn!=NULL) {
			bestNeighbours.insert(C1->bn);
		}

		if (!cambioHecho) {
			//For each neighbour community of the joined communities
			for (nb_it=C1->community_cuts1.begin();nb_it!=C1->community_cuts1.end();nb_it++) {
				//If the best neighbour was one of the two joined ones
				if (((*nb_it)->bn!=NULL)&&(((*nb_it)->bn->C2 == C1)||((*nb_it)->bn->C2 == C2))) {
					bestNeighbours.erase((*nb_it)->bn);
					//Recompute
					(*nb_it)->computeBestNeighbour();

					if ((*nb_it)->bn!=NULL) {
						bestNeighbours.insert((*nb_it)->bn);
					}
				}
			}
		}
		else {
			//For each neighbour community of the joined communities
			for (set_it=C1->community_cuts.begin();set_it!=C1->community_cuts.end();set_it++) {
				//If the best neighbour was one of the two joined ones
				if (((*set_it)->C2->bn!=NULL)&&(((*set_it)->C2->bn->C2 == C1)||((*set_it)->C2->bn->C2 == C2))) {
					bestNeighbours.erase((*set_it)->C2->bn);
					//Recompute
					(*set_it)->C2->computeBestNeighbour();

					if ((*set_it)->C2->bn!=NULL) {
						//printBN();
	//					std::cout << "Hay un insert 2" << std::endl;
						bestNeighbours.insert((*set_it)->C2->bn);
						//printBN();
					}
				}
			}
		}
		delete(C2);
		std::list<Community*>::iterator it_del;
		it_del = std::find(listCommunities->begin(), listCommunities->end(), C2);
		listCommunities->erase(it_del);
	}

//std::cout << "Kmax: " << kmax << std::endl;
//std::cout << "K(V): " << 2*network->tEdges() << std::endl;
	if ((0)&&(!cambioHecho)) {
//	if (((kmax > sqrt(2*network->tEdges()))&&(!cambioHecho))) {
//	if (((kmax > bestNeighbours.size())&&(!cambioHecho))) {
		cambioHecho = true;
		std::cout << "t: " << newT << " Cambiando vectores x mapas... ";
		std::cout << "Comunidades: " << bestNeighbours.size() << std::endl;
		std::cout << "Primera: (vecinos) " << (*bestNeighbours.begin())->C1->tDegrees() << std::endl;
		std::list<Community*>::iterator comm_it;
		for (comm_it=listCommunities->begin();comm_it!=listCommunities->end();comm_it++) {
			if (((*comm_it)->removed)==false) {
				(*comm_it)->cambiarVectorXMap();
			}
		}
		std::cout << "Listo." << std::endl;
	}

	T = newT;

}

void SolutionSubmodular::rejectNeighbour() {
//	std::cout << "rejectNeighbour" << std::endl;
}

float SolutionSubmodular::evaluateNeighbour() {
	return newT;
}

float SolutionSubmodular::evaluate() {
//	return Q - deltaQJump + (mNum/mDen) * (1 - T);
	return Q + (mNum/mDen) * (1 - T);
}

