#ifndef _SOLUTION_SUBMODULAR_H_
#define _SOLUTION_SUBMODULAR_H_

#include "solution.h"
#include "community.h"
#include <vector>
#include "graph.h"
#include "network.h"
#include "ordered_list.h"
#include <set>

class SolutionSubmodular : public Solution {

  private:
	std::list<Community*>* listCommunities;
	Network* network;
	std::list<std::list<Community*> > listJoins;
	std::list<int> listCuts;

	std::multiset<bestNeighbour*, Compare> bestNeighbours;

	float deltaMNum; //Pendiente, sin dividir por K(V)^2
	float mNum;
	float mDen;
	float QNum;
	float QDen;
	float Q;
	float T;
	float newT;
	bool deltaQComputed;
	float deltaQJump; //In case of proyected Q
	int m2;
	float kmax;
	bool cambioHecho;

	Community* selected_community;

  public:
	bool virtual proposeNeighbour();
	void virtual acceptNeighbour();
	void virtual rejectNeighbour();

	float virtual evaluateNeighbour();
	float virtual evaluate();
	float inline getQt() { return Q; }
	float inline getT() { return T; }
	SolutionSubmodular(std::list<Community*>& m_listCommunities, Network* m_network);

	void printBN();
};

#endif

