#include "log.h"
#include "types.h"
#include "community.h"

bool bestNeighbourOrder(const bestNeighbourPtr& bn1, const bestNeighbourPtr& bn2) { 
	if (bn1->num*bn2->den != bn2->num*bn1->den)
		return (bn1->num*bn2->den > bn2->num*bn1->den);
	else
		if (bn1->C1 != bn2->C1)
			return (bn1->C1 > bn2->C1);
		return (bn1->C2 > bn2->C2);
}

//Rainbow colors
tColor magenta = { 1.0, 0.2, 1.00};
tColor blue = { 0.2, 0.2, 1.00};
tColor cyan = { 0.2, 1.0, 1.00};
tColor green = { 0.2, 1.0, 0.2};
tColor yellow = { 1.0, 1.0, 0.00};
tColor red = { 1.0, 0.2, 0.2};

//Colors list for color images
std::vector<std::pair<tColor, float> > rainbow;

//B&W scale
tColor white = { 2.0, 2.0, 2.0};
tColor gray = { 0.7, 0.7, 0.7};
tColor black = { 0.0, 0.0, 0.0}; 

//Colors list for B&W images
std::vector<std::pair<tColor,float> > blackwhite;

float pi = 4.0 * atan(1.0);

class Init {
  public:
	Init() {
		rainbow.push_back(std::make_pair<tColor, float>(magenta, 0.01));
		rainbow.push_back(std::make_pair<tColor, float>(blue, 0.20));
		rainbow.push_back(std::make_pair<tColor, float>(cyan, 0.35));
		rainbow.push_back(std::make_pair<tColor, float>(green, 0.50));
		rainbow.push_back(std::make_pair<tColor, float>(yellow, 0.65));
		rainbow.push_back(std::make_pair<tColor, float>(red, 0.97));

		blackwhite.push_back(std::make_pair<tColor, float>(white, -0.75));
		blackwhite.push_back(std::make_pair<tColor, float>(gray, 0.41));
		blackwhite.push_back(std::make_pair<tColor, float>(black, 1.23));
	}
};

Init init;

Log logCore("log/cores.log");
Log logGomoryHu("log/gomory_hu.log");
Log logGomoryHu2("log/gomory_hu2.log");
Log logGomoryHu3("log/gomory_hu3.log");
Log logGomoryHu4("log/gomory_hu4.log");
Log logGomoryHu5("log/gomory_hu5.log");
Log logCommunities("log/communities.log");

Log logKMax("log/kmax.log");
Log logKMin("log/kmin.log");
Log logTInicial("log/tinicial.log");
Log logTMedio("log/tmedio.log");
Log logTFinal("log/tfinal.log");

float min(float a, float b) {
	if (a<b)
		return a;
	return b;
}

float max(float a, float b) {
	if (a>b)
		return a;
	return b;
}

