#ifndef _TYPES_H_
#define _TYPES_H_

#include "log.h"
#include "math.h"
#include <vector>
#include <map>

class Community;

extern float pi;

//A struct for accesing the best neighbour of a community in terms of submodularity
class bestNeighbour {
  public:
	Community* C1;
	Community* C2;
	float num, den;
};

typedef bestNeighbour* bestNeighbourPtr;
extern bool bestNeighbourOrder(const bestNeighbourPtr& bn1, const bestNeighbourPtr& bn2);

class Compare {
  public:
	bool operator()(const bestNeighbourPtr& bn1, const bestNeighbourPtr& bn2) { return bestNeighbourOrder(bn1, bn2);};
};

typedef struct {
	float xi, yi;
	int dirxi, diryi;
} tLetra;

typedef struct {
	float r, g, b;
} tColor;

//Rainbow colors
extern tColor magenta;
extern tColor blue;
extern tColor cyan;
extern tColor green;
extern tColor yellow;
extern tColor red;

//B&W scale
extern tColor white;
extern tColor gray;
extern tColor black;

typedef struct {
	float xi, yi, dirxi, diryi;
} tImagePosition;

//Colors list for color images
extern std::vector<std::pair<tColor, float> > rainbow;

//Colors list for B&W images
extern std::vector<std::pair<tColor,float> > blackwhite;

extern Log logCore;
extern Log logGomoryHu;
extern Log logGomoryHu2;
extern Log logGomoryHu3;
extern Log logGomoryHu4;
extern Log logGomoryHu5;

extern Log logCommunities;
extern Log logKMin;
extern Log logKMax;
extern Log logTInicial;
extern Log logTMedio;
extern Log logTFinal;

extern Log result_communities;

extern std::map<std::pair<int, int>, int> mapa_si_conn;
extern std::map<std::pair<int, float>, int> mapa_si_conn_norm; //Conectividad normalizada por el producto de los tamaños de los clusters
extern std::vector<float> mapa_si_kconn; //Cantidad de pares kconectados por minShellIndex
extern std::vector<float> mapa_si_nokconn; //Cantidad de pares no kconectados por minShellIndex
extern std::map<std::pair<void*, void*>, float> mapa_cluster_cluster_conn; //Cluster-cluster-conn norm;

float min(float a, float b);
float max(float a, float b);

#endif

